<?php
    // Variables
    $_SESSION['title'] = 'Visualización';
    $pin = '../../../';
    $head_2 = ''.
        "<link rel='stylesheet' href='{$pin}lib/css/style_caja.css'>";
    $body_2 = ''.
        "<script src='https://d3js.org/d3.v7.min.js'></script>";
    // Incluir las clases y funciones para las conexiones a la base de datos
    include_once $pin.'connection/cnx_bd.php';
    $c = new Conexion();$reg = $c->conectar_1();
    // Obtener los padres
    $padre = $reg->prepare("SELECT id_hash as id,CONCAT('(A) ',nombre,' ',paterno,' ',materno) as nombre,CONCAT('ESTRUCTURA') as padre FROM td_estructura_operativa WHERE activo = 1");
    $padre->execute();$padre = $padre->fetchAll(PDO::FETCH_ASSOC);
    // Obtener los hijos
    $hijos = $reg->prepare("SELECT  c1.id_hash as id, CONCAT('(P) ',c2.nombre,' ',c2.paterno,' ',c2.materno) as nombre, c1.id_hash_padre as padre FROM td_registro c1 INNER JOIN td_datos_personales c2 ON c1.id_hash = c2.id_hash WHERE c1.activo = 1 AND c1.id_hash_padre IS NOT NULL");
    $hijos->execute();$hijos = $hijos->fetchAll(PDO::FETCH_ASSOC);
    // Obtener la lista de registros
    $registros = array(array(array("id" => "ESTRUCTURA","nombre" => "ESTRUCTURA")),$padre,$hijos);
?>
<!DOCTYPE html>
<html lang="es">
<?php include $pin.'include/head.php'?>
<body>
<div class="contenedor" style="max-width: 100%;height:100%;"><div class="caja tam1 boto_2" id="visualizacion" style="height: calc(100% - 40px);padding:20px;"></div></div>
<script>var pin = '<?php echo $pin?>';</script>
<?php include $pin.'include/body.php'?>
<script>
    // Obtener la lista de registros
    var registros = <?php echo json_encode($registros)?>.map((x) => {return x.map((a) => {if('padre' in a){a.padre = [a.padre]}return a})});
    // Generar los margenes
    var margenes = {top: 0,bottom: 0,left: 0,right: 0}
    // Tamaño del SVG
    var largo = 0
    var ancho = 0
    // Tamaño total de la grafica
    var total_largo = largo + margenes.left + margenes.right
    var total_ancho = ancho + margenes.top + margenes.bottom
    // Agregar el elementos SVG
    var imagen = d3.select('#visualizacion').append('svg').attr('width', total_largo).attr('height', total_ancho)//.attr('viewBox','0 0 1000 1000')
    // Agregar las agrupaciones de datos
    var grupos = imagen.append('g').attr('transform', "translate(" + margenes.left + "," + margenes.top + ")")
    // Calcular profundidad
    registros.forEach((l, i) => l.forEach(n => n.level = i));
    // Obtener los nodos indexados
    var conexions = registros.reduce(((a, x) => a.concat(x)), []);
    var conexions_index = {};
    conexions.forEach(d => conexions_index[d.id] = d);
    // Idnetificar los nodos clave
    conexions.forEach(d => {d.padre = (d.padre === undefined ? [] : d.padre).map(p => conexions_index[p])})
    // Calcular los paquetes
    registros.forEach((l, i) => {
        // Almacenar indices
        var index = {}
        // Recorrer la matriz
        l.forEach(n => {
            // Evaluar el total de datos
            if (n.padre.length == 0) {return}
            // Generar id de datos
            var id = n.padre.map(d => d.id).sort().join('--')
            // Evaluar si el id existe en los indices
            if(id in index){index[id].padre = index[id].padre.concat(n.padre)}
            else {index[id] = {id: id,padre: n.padre.slice(),level: i}}
            // Agregar el paquete
            n.bundle = index[id]
        })
        // Indexar el paquete
        l.bundles = Object.keys(index).map(k => index[k])
        l.bundles.forEach((b, i) => b.i = i)
    })
    // Agregar las conexiones
    var links = []
    conexions.forEach(d => {d.padre.forEach(p => links.push({source: d,bundle: d.bundle,target: p}))})
    // Integrar los paquetes
    var bundles = registros.reduce(((a, x) => a.concat(x.bundles)), [])
    // Puntear de forma inversa padre-hijo
    bundles.forEach(b => b.padre.forEach(p => {
        // Agregar el objeto - padre
        if(p.bundles_index === undefined){p.bundles_index = {}}
        // Integrar el objeto - hijo
        if(!(b.id in p.bundles_index)) {p.bundles_index[b.id] = []}
        // Enlazar padre - hijo
        p.bundles_index[b.id].push(b)
    }))
    conexions.forEach(n => {
        // Agregar los paquetes
        if(n.bundles_index !== undefined){n.bundles = Object.keys(n.bundles_index).map(k => n.bundles_index[k])}
        // Paquete sin existencia
        else {n.bundles_index = {};n.bundles = []}
        // Enlaza los paquetes
        n.bundles.forEach((b, i) => b.i = i)
    })
    // Limpiar el listado de paquetes
    links.forEach(l => {if (l.bundle.links === undefined){l.bundle.links = []}l.bundle.links.push(l)})
    // Disposiciones
    const padding = 10
    const node_height = 22
    const node_width = 150
    const bundle_width = 14
    const level_y_padding = 16
    const metro_d = 4
    const c = 16
    const min_family_height = 16
    // Agregar el ancho de cada nodo
    conexions.forEach(n => n.height = (Math.max(1, n.bundles.length) - 1) * metro_d)
    // Desplazamiento de los nodos
    var x_offset = padding
    var y_offset = padding
    registros.forEach(l => {
        x_offset += l.bundles.length * bundle_width
        y_offset += level_y_padding
        l.forEach((n, i) => {
            n.x = n.level * node_width + x_offset
            n.y = node_height + y_offset + n.height / 2
            y_offset += node_height + n.height
        })
    })
    // Agergar tamaño a los nodos
    var i = 0
    registros.forEach(l => {l.bundles.forEach(b => {b.x = b.padre[0].x + node_width + (l.bundles.length - 1 - b.i) * bundle_width;b.y = i * node_height});i += l.length})
    links.forEach(l => {
        l.xt = l.target.x
        l.yt = l.target.y + l.target.bundles_index[l.bundle.id].i * metro_d - l.target.bundles.length * metro_d / 2 + metro_d / 2
        l.xb = l.bundle.x
        l.xs = l.source.x
        l.ys = l.source.y
    })
    // Comprimir el espacio vertical
    var y_negative_offset = 0
    registros.forEach(l => {y_negative_offset += -min_family_height + d3.min(l.bundles, b => d3.min(b.links, link => (link.ys - c) - (link.yt + c))) || 0;l.forEach(n => n.y -= y_negative_offset)})
    // Arreglar espacios
    links.forEach(l => {
        l.yt = l.target.y + l.target.bundles_index[l.bundle.id].i * metro_d - l.target.bundles.length * metro_d / 2 + metro_d / 2
        l.ys = l.source.y
        l.c1 = l.source.level - l.target.level > 1 ? node_width + c : c
        l.c2 = c
    })
    // Integrar grupo
    const cluster = d3.cluster().size([largo,ancho]);
    const root = d3.hierarchy(links);
    cluster(root);
    let oValues = Object.values(root)[0];
    let linkks = oValues.map(x => x.bundle.links)
    var colores = ['#ec7063','#a569bd','#5dade2','#45b39d','#f1c40f','#f39c12']
    var color_1 = -1,color_2 = -1,color_3 = -1
    // Agregar atributos y etiquetas
    linkks.forEach((linkk,index) => {
        let nodeG1 = imagen.append("g")
            .selectAll("circle")
            .data(linkk)
            .join("circle")
            .attr("cx", d => d.target.x)
            .attr("cy", d => d.target.y)
            .attr("fill",  "#c80378")
            .attr("stroke","#c80378")
            .attr("r", 5)
        let nodeG11 = imagen.append("g")
            .selectAll("circle")
            .data(linkk)
            .join("circle")
            .attr("cx", d => d.source.x)
            .attr("cy", d => d.source.y)
            .attr("fill",  (d) => {color_1 = colores.length - 1 == color_1 ? 0 : color_1 + 1;return colores[color_1]})
            .attr("stroke",(d) => {color_2 = colores.length - 1 == color_2 ? 0 : color_2 + 1;return colores[color_2]})
            .attr("r", 5)
        let nodeG2 = imagen.append("g")
            .attr("font-size", 12)
            .selectAll("text")
            .data(linkk)
            .join("text")
            .attr("class", "text")
            .attr("x", d => d.target.x + padding)
            .attr("y", d => d.target.y)
            .text(d => d.target.nombre )
            .attr("fill","#23262F");
        let nodeG22 = imagen.append("g")
            .attr("font-size", 12)
            .selectAll("text")
            .data(linkk)
            .join("text")
            .attr("class", "text")
            .attr("x", d => d.source.x + padding)
            .attr("y", d => d.source.y)
            .text(d => d.source.nombre )
            .attr("fill","#2f3341");
        let nodeG = imagen.append('g')
            .attr('class', 'node')
            .selectAll("path")
            .data(linkk)
            .join('path')
            .attr("class", "link")
            .attr("d", d3.linkHorizontal()
                .source(d => [d.xs, d.ys])
                .target(d => [d.xt, d.yt]))
            .attr("fill", "none")
            .attr("stroke-width", 1)
            .attr("stroke",(d) => {color_3 = colores.length - 1 == color_3 ? 0 : color_3 + 1;return colores[color_3]});
    });
    // Quitar pantalla de carga
    carga(false,1);
</script>
</body>
</html>