<!DOCTYPE html>
<html>
<head>
    <title>Extraer contenido de ZIP</title>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js"></script>
</head>
<body>
    <input type="file" id="zipFile" accept=".zip">
    <button onclick="extractContent()">Extraer Contenido</button>
    <pre id="content"></pre>

    <script>
        async function extractContent() {
            const zipFile = document.getElementById('zipFile').files[0];
            const contentArea = document.getElementById('content');

            if (!zipFile) {
                contentArea.textContent = "Por favor, selecciona un archivo ZIP.";
                return;
            }

            try {
                const zip = new JSZip();
                const data = await zip.loadAsync(zipFile);
                console.log(data)

                let extractedContent = "";

                // Itera sobre las entradas del ZIP usando Object.keys
                Object.keys(data.files).forEach(async (filename) => {
                    const file = data.files[filename];

                    if (!file.dir && (filename.endsWith('.csv') || filename.endsWith('.txt'))) {
                        const fileContent = await file.async("string");
                        extractedContent += `\nContenido de ${filename}:\n${fileContent}\n`;
                    }
                });

                // Espera a que todas las promesas de extracción se completen
                await Promise.all(Object.keys(data.files));
                contentArea.textContent = extractedContent || "No se encontraron archivos CSV o TXT en el ZIP.";

            } catch (error) {
                contentArea.textContent = "Error al procesar el archivo ZIP: " + error.message;
            }
        }
    </script>
</body>
</html>