// Ruta base de los delos
var modelos = `${pin}/lib/plugin/models/`
// Guardar las funciones del cropper
var cropper = 0;
// Cargar los modelos
Promise.all([
    faceapi.nets.ssdMobilenetv1.loadFromUri(modelos),
    faceapi.nets.ageGenderNet.loadFromUri(modelos),
    faceapi.nets.faceExpressionNet.loadFromUri(modelos),
    faceapi.nets.faceLandmark68Net.loadFromUri(modelos),
    faceapi.nets.faceLandmark68TinyNet.loadFromUri(modelos),
    faceapi.nets.faceRecognitionNet.loadFromUri(modelos),
    faceapi.nets.ssdMobilenetv1.loadFromUri(modelos),
    faceapi.nets.tinyFaceDetector.loadFromUri(modelos),
]).then()
// Funcion para validar los documentos
async function documento_validar(){
    // Mostrar el estatus
    $('.status').html('FOTOGRAFÍA CAPTURADA').attr('class','status back_verde')
    // Mostrar el resultado de la deteccion
    return 1
}
// Funcion para hacer un recocimiento facial a las imagenes
async function fotografia_validar(){
    // Obtener los elementos html
    const video = document.getElementById('video')
    const canva = document.getElementById('canva').getContext('2d')
    // Obtener el tamaño del canva
    const tamanio = { width: video.offsetWidth, height: video.offsetHeight}
    // Agregar las dimensiones al canva
    faceapi.matchDimensions(canva.canvas, tamanio)
    // Detectar rostro
    const deteccion = await faceapi.detectAllFaces(video, new faceapi.SsdMobilenetv1Options())
    // Obtener el resultado de la deteccion
    const resultado = faceapi.resizeResults(deteccion, tamanio)
    // Limpiar el canva
    canva.clearRect(0, 0, canva.canvas.width, canva.canvas.height)
    // Evaluar el resultado
    if (resultado.length > 0) {
        // Crear caja para mostrar el resultado
        const box = resultado[0].box
        canva.strokeStyle = '#48b961'
        canva.lineWidth = 5
        canva.strokeRect(box.x - (box.width * .5), box.y - (box.height * .75), box.width * 2, box.height * 2)
        // Mostrar el estatus
        $('.status').html('FOTOGRAFÍA VÁLIDA').attr('class','status back_verde')
        // Mostrar el estatus
    } else {$('.status').html('FOTOGRAFÍA NO VÁLIDA').attr('class','status back_rojo')}
    // Mostrar el resultado de la deteccion
    return resultado.length == 1 ? 1 : 0
}
// Funcion para hacer reconocimiento de credencial - frente
async function credencial_frente_validar(imagen){
    // Mostrar el resultado de la deteccion
    return Tesseract.recognize(imagen)
        .then((r) => {
            // Obtener el texto de la imagen
            var texto = r.data.text.toUpperCase()
            // Evaluar si la imagen es una credencial de elector
            if (texto.includes('INSTITUTO NACIONAL ELECTORAL') ||
                texto.includes('INSTITUTO NACIONAL') ||
                texto.includes('NACIONAL ELECTORAL') ||
                texto.includes('INSTITUTO FEDERAL ELECTORAL') ||
                texto.includes('INSTITUTO FEDERAL') ||
                texto.includes('FEDERAL ELECTORAL')
            ){
                // Mostrar el estatus
                $('.status').html('FOTOGRAFÍA VÁLIDA').attr('class','status back_verde')
                // Validar la fotografia
                r = 1
            } else {
                // Mostrar el estatus
                $('.status').html('FOTOGRAFÍA NO VÁLIDA').attr('class','status back_rojo')
                // Invalidar la fotografia
                r = 0
            }
            // Mostrar la validacion
            return r
        })
        .catch((e) => {
            // Mostrar el estatus
            $('.status').html('FOTOGRAFÍA NO VÁLIDA').attr('class','status back_rojo')
            // Mandar el error
            return 0
        })
}
// Funcion para hacer reconocimiento de credencial - atras
async function credencial_atras_validar(imagen){
    // Mostrar el resultado de la deteccion
    return Tesseract.recognize(imagen)
        .then((r) => {
            // Obtener el texto de la imagen
            var texto = r.data.text.toUpperCase()
            // Evaluar si la imagen es una credencial de elector
            if(texto.includes('<<') || texto.includes('ESTE DOCUMENTO')){
                // Mostrar el estatus
                $('.status').html('FOTOGRAFÍA VÁLIDA').attr('class','status back_verde')
                // Validar la fotografia
                r = 1
            } else {
                // Mostrar el estatus
                $('.status').html('FOTOGRAFÍA NO VÁLIDA').attr('class','status back_rojo')
                // Invalidar la fotografia
                r = 0
            }
            // Mostrar la validacion
            return r
        })
        .catch((e) => {
            // Mostrar el estatus
            $('.status').html('FOTOGRAFÍA NO VÁLIDA').attr('class','status back_rojo')
            // Mandar el error
            return 0
        })
}
// Funcion para mostrar la ventana de fotografia viva - Camara
async function activar_camaras(name,html){
    // Variables para almacenar los datos del archivo
    var datos = {}
    var cambio_f = ''
    var cambio_v = 0
    // Evaluar si el navegador es chrome
    if(navegador()){
        // Solicitar acceso a las cámaras
        navigator.mediaDevices.getUserMedia({video: true}).then(async (stream) => {
            // Obtener la lista de dispositivos
            var devices = await navigator.mediaDevices.enumerateDevices()
            // Obtener el filtro de dispositivos
            var filtros = [...devices].filter((x) => {return !x.kind.includes('audio')})
            // Obtener la lista de camaras
            var camaras = [];i = 1;for(let x in filtros){camaras.push(`<option value="${filtros[x].deviceId}">Cámara ${i}${filtros[x].label.includes('FRONT') ? ' - FRONTAL' : (filtros[x].label.includes('BACK') ? ' - TRASERA' : '')}</option>`);i++}
            // Evaluar la lista de camaras
            if(camaras.length > 0){
                // Mostrar ventana
                Swal.fire({
                    width: 500,
                    title: 'Fotografía',
                    html: `
                        <div class="status back_gris">SIN FOTOGRAFÍA CAPTURADA</div>
                        <div class="imagen">
                            <video  id="video" autoplay muted></video>
                            <canvas id="canva"></canvas>
                            ${name == 'credencial_frente' || name == 'credencial_atras' ? '<div class="credencial"></div>' : ''}
                        </div>
                        <div class="pregunta topi_1" style="width:100%;margin:0;">
                            <div class="pregunta_texto">Lista de cámaras</div>
                            <select class="pregunta_input cameras">${camaras.join('')}</select>
                        </div>
                        <button class="boton capturar back_rosa"  style="width:calc(50% - 10px);margin: 20px 0 0 20px;"><div class="boton_icon"><i class="fa-solid fa-check"></i></div><div class="boton_text">CAPTURAR</div></button>
                        <button class="boton denuevos back_negro" style="width:calc(50% - 10px);margin: 20px 0 0 0;"><div class="boton_icon"><i class="fa-solid fa-rotate-right"></i></div><div class="boton_text">OTRA TOMA</div></button>
                        `,
                    showCancelButton: true,
                    confirmButtonText: 'Guardar',
                    cancelButtonText: 'Cancelar',
                    allowOutsideClick: false,
                }).then((r) => {
                    // Evaluar la respuesta del usuario
                    if(typeof window[name] !== 'undefined'){window[name] = r.isConfirmed ? cambio_f : window[name]}
                    if(typeof window[`val_${name}`] !== 'undefined'){window[`val_${name}`] = r.isConfirmed ? cambio_v : window[`val_${name}`]}
                    // Cambiar la imagen
                    if(name !== 'fotografia_viva'){
                        // Evaluar la respuesta del usuario
                        if(r.isConfirmed && cambio_f !== ''){
                            // Mostrar los datos
                            html.find('.archivo_nombre').html(datos.nombre)
                            html.find('.archivo_tamano').html(datos.text)
                            html.find('.archivo_icono').html('<i class="fa-solid fa-file-image"></i>')
                            html.closest('.archivo_cajas').find('.archivo_views').removeClass('disabled').html('<i class="fa-solid fa-eye"></i>')
                            html.css('border-color','var(--verde_1)').css('color','var(--verde_1)')
                            asteriscos(html,true)
                        } else {}
                    } else{$('.fotografia_viva img').attr('src',window[name] !== '' ? window[name] : `${pin}lib/img/usuario.png`)}
                })
                // Deshabilitar el boton
                $('.swal2-confirm').prop('disabled',true)
                // Obtener el video y el canva
                const video = document.getElementById('video')
                const canva = document.getElementById('canva').getContext('2d')
                // Funcion para cambiar de camara
                $(document).off('change','.cameras').on('change','.cameras',function(){
                    // Cambiar de camara
                    navigator.mediaDevices.getUserMedia({video:{deviceId:{exact:$(this).val()}}}).then(stream => {video.srcObject = stream}).catch(error => error(error))
                })
                // Funcion para capturar la imagen
                $(document).off('click' ,'.capturar').on('click' ,'.capturar',async function(){
                    // Mostrar la pantalla de carga
                    carga(true,1)
                    // Detener el video
                    video.pause()
                    // Crear un elemento para almacenar la imagen
                    const nuevo = document.createElement('canvas');
                    // Obtener el tamaño de la imagen
                    nuevo.width = video.videoWidth
                    nuevo.height = video.videoHeight
                    // Obtener el contenido del video
                    const ctx = nuevo.getContext('2d')
                    // Insertar la imagen en el canva
                    ctx.drawImage(video, 0, 0, nuevo.width, nuevo.height)
                    // Agregar la imagen
                    cambio_f = nuevo.toDataURL('image/jpeg')
                    // Evaluar el tipo de fotografia
                    if(false){}
                    else if(name == 'fotografia_viva'){cambio_v = await fotografia_validar()}
                    else if(name == 'credencial_frente'){cambio_v = await credencial_frente_validar(cambio_f)}
                    else if(name == 'credencial_atras'){cambio_v = await credencial_atras_validar(cambio_f)}
                    else {cambio_v = await documento_validar()}
                    // Quitar pantalla de carga
                    carga(false,1)
                    // Habilitar el guardado
                    $('.swal2-confirm').prop('disabled',false)
                })
                // Funcion para tomar de nuevo la imagen
                $(document).off('click' ,'.denuevos').on('click' ,'.denuevos',function(){
                    // Deshabilitar el guardado
                    $('.swal2-confirm').prop('disabled',true)
                    // Mostrar el estatus
                    $('.status').html('SIN FOTOGRAFÍA CAPTURADA').attr('class','status back_gris')
                    // Detener el video
                    video.play()
                    // Limpiar variables
                    cambio_f = ''
                    cambio_v = 0
                })
                // Evaluar captura del rostro
                if(false){
                    // Agregar funcion play para el video
                    video.addEventListener('play', async () => {
                        // Obtener el tamaño del canva
                        const tamanio = { width: video.offsetWidth, height: video.offsetHeight}
                        // Agregar las dimensiones al canva
                        faceapi.matchDimensions(canva.canvas, tamanio)
                        // Agregar un intervalo a las detecciones
                        setInterval(async () => {
                            // Detectar rostro
                            const deteccion = await faceapi.detectAllFaces(video, new faceapi.SsdMobilenetv1Options())
                            // Obtener el resultado de la deteccion
                            const resultado = faceapi.resizeResults(deteccion, tamanio)
                            // Limpiar el canva
                            canva.clearRect(0, 0, canva.canvas.width, canva.canvas.height)
                            // Evaluar el resultado
                            if (resultado.length > 0){
                                // Crear caja para mostrar el resultado
                                const box = resultado[0].box
                                canva.strokeStyle = '#48b961'
                                canva.lineWidth = 5
                                canva.strokeRect(box.x, box.y, box.width, box.height)
                                cambio_v = 1
                            } else {cambio_v = 0}
                        }, 1000)
                    })
                } else {cambio_v = 1}
                // Activar la camara predeterminada por el dispositivo
                navigator.mediaDevices.getUserMedia({video:{deviceId:{exact:$('.camaras').val()}}}).then(stream => {video.srcObject = stream})
                // Mostrar error sobre el soporte del dispositivo
            } else {Swal.fire({width: 400,icon: 'error',html: 'Su dispositivo no soporta esta función'})}
            // Mostrar error de acceso denegado
        }).catch(e => {Swal.fire({width: 400,icon: 'error',html: 'Su dispositivo no soporta esta función'})})
    } else {}
}
// Funcion para activar la galeria
async function activar_galeria(name,html){
    // Titulos
    var titulos = {
        fotografia_viva: 'FOTOGRAFÍA VIVA',
        formato_registro: 'FROMATO DE REGISTRO',
        comprobante_domicilio: 'COMPROBANTE DE DOMICILIO',
        credencial_frente : 'CREDENCIAL FRENTE',
        credencial_atras : 'CREDENCIAL ATRÁS'
    }
    // Variables para almacenar los datos del archivo
    var datos = {}
    var cambio_f = ''
    var cambio_v = 0
    // Mostrar ventana
    Swal.fire({
        width: 500,
        title: titulos[name],
        html: `
            <div class="status back_gris">SIN FOTOGRAFÍA CAPTURADA</div>
            <div class="imagen">
                <img    id="video" src="${window[name] !== '' ? window[name] : `${pin}lib/img/${name !== 'fotografia_viva' ? 'captura' : 'usuario'}.png`}">
                <embed  id="docum" src="" class="none" type="application/pdf"/>
                <canvas id="canva"></canvas>
            </div>
            <div class="cropper none">
                <button class="cropper_btns" id="cropper_move"><i class="fa-solid fa-arrows-up-down-left-right"></i></button>
                <button class="cropper_btns" id="cropper_crop"><i class="fa-solid fa-crop-simple"></i></button>
                <button class="cropper_btns" id="cropper_zoom1"><i class="fa-solid fa-magnifying-glass-plus"></i></button>
                <button class="cropper_btns" id="cropper_zoom0"><i class="fa-solid fa-magnifying-glass-minus"></i></button>
                <button class="cropper_btns" id="cropper_move_l"><i class="fa-solid fa-arrow-left"></i></button>
                <button class="cropper_btns" id="cropper_move_r"><i class="fa-solid fa-arrow-right"></i></button>
                <button class="cropper_btns" id="cropper_move_t"><i class="fa-solid fa-arrow-up"></i></button>
                <button class="cropper_btns" id="cropper_move_b"><i class="fa-solid fa-arrow-down"></i></button>
                <button class="cropper_btns" id="cropper_rotate_l"><i class="fa-solid fa-arrow-rotate-left"></i></button>
                <button class="cropper_btns" id="cropper_rotate_d"><i class="fa-solid fa-arrow-rotate-right"></i></button>
                <button class="cropper_btns" id="cropper_scale_x"><i class="fa-solid fa-arrows-left-right"></i></button>
                <button class="cropper_btns" id="cropper_scale_y"><i class="fa-solid fa-arrows-up-down"></i></button>
            </div>
            <div class="pregunta_texto topi_2 boto_1" style="float:left;"><b>NOTA: </b><b class="text_rojo">La carga máxima del archivo es de 2MB</b></div>
            <label class="archivo">
                <input type="file" class="file" name="cambio_f" accept=".jpg, .png, .pdf">
                <div class="archivo_icono"><i class="fa-solid fa-upload"></i></div>
                <div class="archivo_datos text_left">
                    <div class="archivo_nombre">SELECCIONA...</div>
                    <div class="archivo_tamano">0.00 KB</div>
                </div>
            </label>`,
        showCancelButton: true,
        confirmButtonText: 'Guardar',
        cancelButtonText: 'Cancelar',
        allowOutsideClick: false,
    }).then((r) => {
        // Evaluar si el archivo adjuntado es una imagen
        if(!cambio_f.includes('/pdf')){
            // Obtener el canva el cropper
            var cropper_canva = cropper.getCroppedCanvas()
            // Obtener la imagen modificada del canva
            var cropper_image = cropper_canva.toDataURL()
            // Realizar el cambio
            cambio_f = cropper_image
        }
        // Eliminar el cropper
        cropper = 0
        // Evaluar la respuesta del usuario
        if(typeof window[name] !== 'undefined'){window[name] = r.isConfirmed ? cambio_f : window[name]}
        if(typeof window[`val_${name}`] !== 'undefined'){window[`val_${name}`] = r.isConfirmed ? cambio_v : window[`val_${name}`]}
        // Cambiar la imagen
        if(name !== 'fotografia_viva'){
            // Evaluar la respuesta del usuario
            if(r.isConfirmed && cambio_f !== ''){
                // Mostrar los datos
                html.find('.archivo_nombre').html(datos.nombre)
                html.find('.archivo_tamano').html(datos.text)
                html.find('.archivo_icono').html(cambio_f.includes('/pdf') ? '<i class="fa-solid fa-file-pdf"></i>' : '<i class="fa-solid fa-file-image"></i>')
                html.closest('.archivo_cajas').find('.archivo_views').removeClass('disabled').html('<i class="fa-solid fa-eye"></i>')
                html.css('border-color',cambio_f.includes('/pdf') ? 'var(--verde_1)' : 'var(--verde_1)').css('color',cambio_f.includes('/pdf') ? 'var(--verde_1)' : 'var(--verde_1)')
                asteriscos(html,true)
            } else {}
        } else{$('.fotografia_viva img').attr('src',window[name] !== '' ? window[name] : `${pin}lib/img/usuario.png`)}
    })
    // Funcion para cambiar la fotografia actual
    $(document).off('change','input[name="cambio_f"]').on('change','input[name="cambio_f"]',function(){
        // Obtener el archivo
        var element = $(this).closest('label')
        var archivo = $(this)[0].files
        // Evaluar el valor
        if(archivo.length == 1){
            // Agregar la pantalla de carga
            carga(true,1)
            // Obtener la informacion del archivo
            datos.archivo = archivo[0]
            datos.nombre = archivo[0].name
            datos.tamano = archivo[0].size / 1024 / 1024
            datos.fecha = archivo[0].lastModified
            datos.tipo = archivo[0].type.split('/')[1]
            datos.text = archivo[0].size < 1024 * 1024 ? `${(archivo[0].size / 1024).toFixed(2)} KB` : `${(archivo[0].size / (1024 * 1024)).toFixed(2)} MB`
            // Evaluar el tipo de documento
            if(['png','jpg','jpeg'].includes(datos.tipo)){
                // Evaluar el tamaño del archivo
                if(datos.tamano <= 2){
                    // Mostrar las opciones de edicion
                    $('.cropper').removeClass('none')
                    // Ocultar el pdf y mostrar imagen
                    $('#docum').addClass('none')
                    $('#video').removeClass('none')
                    // Crear lector de imagen
                    var leer = new FileReader()
                    leer.onload = () => {cambio_f = leer.result}
                    leer.readAsDataURL(datos.archivo)
                    // Agregar una accion de intervalo
                    setTimeout(async () => {
                        // Evaluar la forografia
                        $('.imagen img').attr('src',cambio_f)
                        if(name == 'credencial_frente'){$('.credencial').remove();$('.imagen').append('<div class="credencial"></div>')}
                        if(name == 'credencial_atras' ){$('.credencial').remove();$('.imagen').append('<div class="credencial"></div>')}
                        // Mostrar los datos
                        element.find('.archivo_nombre').html(datos.nombre)
                        element.find('.archivo_tamano').html(datos.text)
                        element.find('.archivo_icono').html('<i class="fa-solid fa-file-image"></i>')
                        element.css('border-color','var(--verde_1)').css('color','var(--verde_1)')
                        // Evaluar el tipo de fotografia
                        if(false){}
                        else if(name == 'fotografia_viva'){cambio_v = await fotografia_validar()}
                        else if(name == 'credencial_frente'){cambio_v = await credencial_frente_validar($('input[name="cambio_f"]')[0].files[0])}
                        else if(name == 'credencial_atras'){cambio_v = await credencial_atras_validar($('input[name="cambio_f"]')[0].files[0])}
                        else {cambio_v = await documento_validar()}
                        // Activar la funcion para editar las fotografias
                        cropper = new Cropper($('#video')[0],{aspectRatio: 1 / 1})
                        // Quitar la pantalla de carga
                        carga(false,1)
                    },500)
                } else {Swal.fire({width: 400,html:'El archivo es demasiado grande (Máximo 2MB)',icon:'warning'}).then(() => {activar_galeria(name,html)});carga(false,1)}
            } else if(datos.tipo == 'pdf' && ['formato_registro'].includes(name)){
                // Evaluar el tamaño del archivo
                if(datos.tamano <= 2){
                    // Ocultar las opciones de edicion
                    $('.cropper').addClass('none')
                    // Ocultar el pdf y mostrar imagen
                    $('#docum').removeClass('none')
                    $('#video').addClass('none')
                    // Crear lector de imagen
                    var leer = new FileReader()
                    leer.onload = () => {cambio_f = leer.result}
                    leer.readAsDataURL(datos.archivo)
                    // Agregar una accion de intervalo
                    setTimeout(async () => {
                        // Evaluar la forografia
                        $('.imagen embed').attr('src',cambio_f)
                        // Mostrar los datos
                        element.find('.archivo_nombre').html(datos.nombre)
                        element.find('.archivo_tamano').html(datos.text)
                        element.find('.archivo_icono').html('<i class="fa-solid fa-file-pdf"></i>')
                        element.css('border-color','var(--verde_1)').css('color','var(--verde_1)')
                        // Evaluar el tipo de fotografia
                        $('.status').html('DOCUMENTO ADJUNTADO').attr('class','status back_verde')
                        cambio_v = 1
                        // Quitar la pantalla de carga
                        carga(false,1)
                    },500)
                } else {Swal.fire({width: 400,html:'El archivo es demasiado grande (Máximo 2MB)',icon:'warning'}).then(() => {activar_galeria(name,html)});carga(false,1)}
            } else {Swal.fire({width: 400,html:'El archivo debe ser <b>.PNG, .JPG ó .JPEG</b>',icon: 'error'}).then(() => {activar_galeria(name,html)});carga(false,1)}
        } else {}
    })
}
// Cropper - Funciones para modificar las fotografias
var scaleX = -1
var scaleY = -1
$(document).on('click','#cropper_move',function(){cropper.setDragMode("move")})
$(document).on('click','#cropper_crop',function(){cropper.setDragMode("crop")})
$(document).on('click','#cropper_zoom1',function(){cropper.zoom(0.1)})
$(document).on('click','#cropper_zoom0',function(){cropper.zoom(-0.1)})
$(document).on('click','#cropper_move_l',function(){cropper.move(-10,0)})
$(document).on('click','#cropper_move_r',function(){cropper.move(10,0)})
$(document).on('click','#cropper_move_t',function(){cropper.move(0,-10)})
$(document).on('click','#cropper_move_b',function(){cropper.move(0,10)})
$(document).on('click','#cropper_rotate_l',function(){cropper.rotate(-45)})
$(document).on('click','#cropper_rotate_d',function(){cropper.rotate(45)})
$(document).on('click','#cropper_scale_x',function(){cropper.scaleX(scaleX);scaleX = -scaleX})
$(document).on('click','#cropper_scale_y',function(){cropper.scaleY(scaleY);scaleY = -scaleY})
// Funcion para importar un archivo
$(document).on('click' ,'.fotografia',function(){
    // Obtener la etiqueta del archivo a modificar
    var name = $(this).attr('data-name')
    var html = $(this)
    // Evaluar si existe un nombre
    if(name){
        // Mostrar ventana
        Swal.fire({
            width: 400,
            title: 'Fotografía',
            html: `
                <button class="boton back_blanco text_left galeria" style="width:100%;margin:20px 0 0 0;"><div class="boton_icon"><i class="fa-solid fa-caret-right"></i></div><div class="boton_text">Extraer de mis archivos</div></button>
                <button class="boton back_blanco text_left camaras" style="width:100%;margin:20px 0 20px 0;"><div class="boton_icon"><i class="fa-solid fa-caret-right"></i></div><div class="boton_text">Activar cámara</div></button>`,
            showConfirmButton: false,
            showCloseButton: true,
        })
        // Funcion para extraer la foto
        $(document).off('click','.galeria').on('click','.galeria',function(){activar_galeria(name,html)})
        $(document).off('click','.camaras').on('click','.camaras',function(){activar_camaras(name,html)})
    } else {}
})