var nuev_arch = ''
// Funcion para importar datos desde un csv
function import_csv(arch){
    // Leer el archivo
    var read = new FileReader()
    // Crear funcion al leer el archivo
    read.onload = function(e){
        // Obtener el contenido
        var cont = e.target.result
        // Determinar el número de columnas
        var line = cont.split('\n')
        // Evaluar si existen columnas
        if(line.length > 0){
            // Almacenar los encabezados
            var enca = 0
            // Conocer si la primera columna contiene los encabezados
            Swal.fire({
                width: 400,
                html: ''+
                    '<div class="text_just">'+
                        '<div class="preg preg_1 boto_0">'+
                            '<div class="preg_labe" style="height:auto;">Total de filas: '+line.length+'<br>Rango del 1 al '+line.length+'<br><br>Ingrese la fila que contiene los encabezados (0 = Sin encabezados)</div>'+
                            '<input class="preg_inpu mxm" type="tel" value="0" placeholder="Escribe...">'+
                        '</div>'+
                    '</div>',
                confirmButtonText: 'Continuar',
                cancelButtonText:  'Cancelar',
                showCancelButton: true,
                allowOutsideClick: false,
                preConfirm: () => {enca = $('.mxm').val()}
            }).then((result) => {
                // Evaluar la respuesta
                if(result.isConfirmed){
                    // Almacenar el valor de la fila
                    $('.fila').val(enca)
                    // Evaluar el numero del encabezado
                    if(enca > 0){
                        // Obtener la fila de los encabezados
                        enca = line[enca - 1].split(',')
                        // Quitar caracteres expeciales
                        for(i = 0; i < enca.length; i++){
                            // Recrear el encabezado
                            enca[i] = enca[i].replace(/[^a-zA-Z0-9_]+/g,'').toLowerCase()
                            // Evaluar si el nombre es aceptable para la columna
                            if(!isNaN(enca[i]) || /^\d/.test(enca[i]) || enca[i].toLowerCase() == 'id'){
                                // Cambiar el nombre a la columna
                                enca[i] = 'columna'+i
                            // Buscar repetidos
                            } else {
                                k = 0
                                // Recorrer el arreglo
                                for(j = 0; j < enca.length; j++){
                                    // Buscar semejanza
                                    if(enca[i] == enca[j]){k++}
                                } if(k > 1){enca[i] = 'columna'+i}
                            }
                        }
                    } else {
                        // Obtener la fila de los encabezados
                        enca = line[0].split(',')
                        // Cambiar los encabezados
                        for(i = 0; i < enca.length; i++){enca[i] = 'columna'+i}
                    } $('.enca').val(enca.join(','));enca.unshift('id')
                    // Crear el formulario
                    var form = new FormData($('#f_impo')[0])
                    if(nuev_arch !== ''){form.set('arch',nuev_arch)}
                    // Habilitar pantalla de carga
                    carga(true,1)
                    // Subir la informacion
                    $.ajax({
                        type: "POST",
                        url: `${pin}api/insertar.php`,
                        processData: false,
                        contentType: false,
                        data: form,
                        success: (r) => {
                            // Destruir la tabla dinamica
                            t_impo.destroy()
                            // Limpiar las columnas
                            $('#t_impo thead tr').html('')
                            $('#t_impo thead tr').append('<th class="text_cent tabl_tam1"><label class="preg_opci chec"><input type="checkbox" class="sele_ajax"><div class="preg_tipo"><i class="fa-solid fa-check"></i></div></label></th>')
                            $('#t_impo thead tr').append('<th class="text_cent tabl_tam1">Edit.</th>')
                            $('#t_impo thead tr').append('<th class="text_cent tabl_tam1">Elim.</th>')
                            $('#t_impo thead tr').append('<th class="text_cent tabl_tam1">id</th>')
                            $('#t_impo tbody').html('')
                            // Agregar las columnas
                            for(i = 1; i < enca.length; i++){$('#t_impo thead tr').append('<th class="text_cent">'+enca[i]+'</th>')}
                            // Iniciarlizar la tabla
                            setTimeout(() => {
                                t_impo = $('#t_impo').DataTable({
                                    dom: 'QBftipr',
                                    buttons: [edit,elim,colv,guar],
                                    language: utf8,
                                    scrollX: true,
                                    serverSide: true,
                                    deferRender: true,
                                    columnDefs: [{targets: [0,1,2],orderable:false}],
                                    order: [[3,'asc']],
                                    ajax: {url: `${pin}api/buscar.php`,type: 'POST',data: function(d){d.ajax = ['ct_importar',enca];d.length = 10}},
                                }).on('init.dt',function(){coinciden();carga(false,1);$('.dataTables_filter input').attr('placeholder','Buscar...')})
                                // Habilitar caja
                                $('#tarj_impo').removeClass('disa')
                                // Mostrar informacion de importación
                                $('.impo_nomb').html('<i class="fa-solid fa-upload"></i>   Nombre del archivo: <b style="font-weight:800 !important;">'+$('.nomb').val()+'</b>')
                                $('.impo_tama').html('<i class="fa-solid fa-database"></i> Tamaño del archivo: <b style="font-weight:800 !important;">'+$('.size').val()+'</b>')
                            }, 3000)
                        }
                    });
                } else {Swal.fire(toast('success','Se canceló la importación'));import_limpiar();carga(false,1)}
            })
            // Crear funcion para el rango de datos
            $(document).on('input','.mxm',function(){
                // Obtener el maximo y el minimo
                var mini = 1
                var maxi = line.length
                // Obtener el valor del input
                var valu = $(this).val()
                // Evaluar el resultado
                if(valu !== '' && (valu == 0 || (valu >= mini && valu <= maxi))){$('.swal2-confirm').prop('disabled',false)}
                else {$('.swal2-confirm').prop('disabled',true)}
            })
        } else {Swal.fire({width: 400,icon:'error',html:'El archivo esta vacio'});import_limpiar()}
    };read.readAsText(arch)
}
// Funcion para importar datos desde un xlsx
function import_xls(arch){
    // Leer el archivo
    var read = new FileReader()
    // Crear funcion al leer el archivo
    read.onload = function (e) {
        // Obtener el contenido
        var cont = e.target.result;
        // Obtener y convertir los datos del contenido
        var data = new Uint8Array(cont);
        // Leer el archivo de excel
        var libr = XLSX.read(data, { type: 'array' });
        // Obtener el total de hojas
        var tota = libr.SheetNames
        // Obtener el total de hojas con datos
        var nume = 0
        // Obtener el nombre de la hoja que se desea importar
        var nomb = ''
        // Crear las opciones para seleccionar la hoja
        var html = ''
        for(let i = 0; i < tota.length; i++){
            // Saber si la hoja esta vacia
            if(typeof libr.Sheets[tota[i]] !== 'undefined'){
                if(typeof libr.Sheets[tota[i]]['!ref'] !== 'undefined'){
                    // Agregar a las opciones
                    html += ''+
                    '<label class="preg_opci radi">'+
                        '<input type="radio" value="'+tota[i]+'" class="hoja" name="hoja">'+
                        '<div class="preg_tipo"><i class="fa-solid fa-circle"></i></div>'+
                        '<div class="preg_text">'+tota[i]+'</div>'+
                    '</label>';nume++
                } else {}
            } else {}
        } // Crear alerta
        Swal.fire({
            width: 400,
            html: ''+
                '<div class="preg_1 text_just">'+
                    '<div class="preg_labe" style="margin: 10px 0 0 0;">Total de hojas: '+tota.length+'</div>'+
                    '<div class="preg_labe" style="margin:    0 0 0 0;">Total de hojas con datos: '+nume+'</div>'+
                    '<div class="preg_labe" style="margin:    0 0 0 0;">Total de hojas sin datos: '+(tota.length - nume)+'</div>'+
                    '<div class="preg_labe topi_1">Seleccione la hoja que desea importar</div><div class="preg preg_1">'+html+'</div>'+
                '</div>',
            confirmButtonText:'Continuar',
            cancelButtonText: 'Cancelar',
            showCancelButton: true,
            allowOutsideClick: false,
            preConfirm: () => {nomb = $('.hoja:checked').val()}
        }).then((r) => {
            // Evaluar la respuesta del usuario
            if(r.isConfirmed){
                // Obtener los datos de las hojas de excel
                var hoja = libr.Sheets[nomb];
                // Convertir la hoja de excel a csv
                var conv = XLSX.utils.sheet_to_csv(hoja);
                // Convertir el archivo convertido a binario
                var blob = new Blob([conv], {type: 'text/csv'});
                // Crea un nuevo archivo CSV con un nombre diferente si es necesario
                nuev_arch = new File([blob],'importar.csv',{type: 'text/csv'});
                // Importar el nuevo archivo
                import_csv(nuev_arch)
                // Cancelar la importacion
            } else {Swal.fire(toast('success','Se canceló la importación'));import_limpiar();carga(false,1)}
        });$('.swal2-confirm').prop('disabled',true)
        // Crear funcion seleccionar la hoja que contiene los datos
        $(document).on('click','.hoja',function(){$('.swal2-confirm').prop('disabled',false)})
    };
    read.readAsArrayBuffer(arch);
}
// Funcion para limpiar la tabla de importacion
function import_limpiar(){
    // Destruir la tabla dinamica
    t_impo.destroy()
    // Limpiar las columnas
    $('#t_impo thead').html('<tr></tr>')
    $('#t_impo tbody').html('')
    // Agregar las columnas
    for(i = 0; i < 5; i++){$('#t_impo thead tr').append('<th class="tabl_tam1">columna</th>')}
    // Volver a crear la tabla
    setTimeout(() => {t_impo = $('#t_impo').DataTable({dom: 'QBftipr',buttons: [],language: utf8,scrollX: true})}, 100);
    // Vaciar el input
    $('.impo_arch').val('')
    // Ocultar la tabla de importacion
    $('#tarj_impo').addClass('disa')
}
// Funcion para saber si los datos coinciden
function coinciden(){
    // Obtener el total de encabezados
    var head_impo = $('#t_impo thead th').slice(3),i = 0
    var head_crud = $('#t_crud thead th').slice(3),j = 0
    if(!$('#tarj_impo').hasClass('disa')){
        // Incluir el texto
        $('.coin').html('')
        $('.coin').append('<i class="fa-solid fa-caret-right"></i> Asegurese de que las <span style="background:#FFCDD2;padding: 0 5px;border-radius:5px;">columnas</span> de la tabla de importada coincidan con las <span style="background:#BBDEFB;padding: 0 5px;border-radius:5px;">columnas</span> de la tabla de datos originales</div><br>')
        $('.coin').append('<i class="fa-solid fa-caret-right"></i> Cuando las columnas coincidan se sombrearán de color <span style="background:#A5D6A7;padding: 0 5px;border-radius:5px;">verde</span>')
        // Evaluar las similitudes
        if(head_impo.length == head_crud.length){
            // Habilitar boton de guardar
            $('.guar').prop('disabled',false)
            // Sombrear las columnas
            $('#t_crud_wrapper .dataTables_scrollHead thead th').each(function(){if(j > 3){$(this).css('background','var(--coincide_3)')}j++})
            $('#t_impo_wrapper .dataTables_scrollHead thead th').each(function(){if(i > 3){$(this).css('background','var(--coincide_3)')}i++})
        } else {
            // Deshabilitar el boton de guardar
            $('.guar').prop('disabled',true)
            // Sombrear las columnas
            $('#t_crud_wrapper .dataTables_scrollHead thead th').each(function(){if(j > 3){$(this).css('background','var(--coincide_1)')}j++})
            $('#t_impo_wrapper .dataTables_scrollHead thead th').each(function(){if(i > 3){$(this).css('background','var(--coincide_2)')}i++})
        }
    } else {$('#t_crud_wrapper .dataTables_scrollHead thead th').each(function(){if(j > 3){$(this).css('background','inherit')}j++})}
}
// Funcion para tomar el archivo de importacion
$(document).on('change','.impo_arch',function(){
    // Almacenar el archivo
    var arch = $(this)[0].files
    // Evaluar el valor
    if(arch.length == 1){
        // Obtener los datos del archivo
        var arch = arch[0]
        // Obtener el tipo del archivo
        var nomb = arch.name
        var size = (arch.size / (1024 * 1024)) > 1 ? (arch.size / (1024 * 1024)).toFixed(2)+' MB' : (arch.size / 1024).toFixed(2)+' KB'
        var tipo = nomb.slice(nomb.lastIndexOf('.') + 1)
        $('.tipo').val(tipo)
        $('.nomb').val(nomb)
        $('.size').val(size)
        // Evaluar la extension
        if (tipo == 'xlx' || tipo == 'xlsx'){import_xls(arch)}
        if (tipo == 'txt' || tipo == 'csv' ){import_csv(arch)}
    } else {Swal.fire(toast('warning','No se adjunto ningún archivo'));import_limpiar();carga(false,1)}
})
// Ejecutar funcion cada vez que se oculta una columna
$(document).on('click','.buttons-columnVisibility',function(){coinciden()})