var cambio_f = ''
var cambio_v = 0
// Ruta base de los delos
var modelos = `${pin}/lib/plugin/models/`
// Cargar los modelos
Promise.all([
    faceapi.nets.ssdMobilenetv1.loadFromUri(modelos),
    faceapi.nets.ageGenderNet.loadFromUri(modelos),
    faceapi.nets.faceExpressionNet.loadFromUri(modelos),
    faceapi.nets.faceLandmark68Net.loadFromUri(modelos),
    faceapi.nets.faceLandmark68TinyNet.loadFromUri(modelos),
    faceapi.nets.faceRecognitionNet.loadFromUri(modelos),
    faceapi.nets.ssdMobilenetv1.loadFromUri(modelos),
    faceapi.nets.tinyFaceDetector.loadFromUri(modelos),
]).then()
// Funcion para hacer un recocimiento facial a las imagenes
async function fotografia_validar(){
    // Obtener los elementos html
    const video = document.getElementById('video')
    const canva = document.getElementById('canva').getContext('2d')
    // Obtener el tamaño del canva
    const tamanio = { width: video.offsetWidth, height: video.offsetHeight}
    // Agregar las dimensiones al canva
    faceapi.matchDimensions(canva.canvas, tamanio)
    // Detectar rostro
    const deteccion = await faceapi.detectAllFaces(video, new faceapi.SsdMobilenetv1Options())
    // Obtener el resultado de la deteccion
    const resultado = faceapi.resizeResults(deteccion, tamanio)
    // Limpiar el canva
    canva.clearRect(0, 0, canva.canvas.width, canva.canvas.height)
    // Evaluar el resultado
    if (resultado.length > 0) {
        // Crear caja para mostrar el resultado
        const box = resultado[0].box
        canva.strokeStyle = '#48b961'
        canva.lineWidth = 5
        canva.strokeRect(box.x, box.y, box.width, box.height)
    } else {}
    // Quitar la pantalla de carga
    carga(false,1)
    // Mostrar el resultado de la deteccion
    return resultado.length == 1 ? 1 : 0
}
// Funcion para mostrar la ventana de fotografia viva - Galeria
async function fotografia_galeria(){
    // Mostrar ventana
    Swal.fire({
        width: 500,
        title: 'Fotografía',
        html: `
            <div class="imagen">
                <img    id="video" src="${fotografia_viva !== '' ? fotografia_viva : `${pin}lib/img/usuario.png`}">
                <canvas id="canva"></canvas>
            </div>
            <label class="archivo topi_2">
                <input type="file" class="file" name="cambio_f" accept=".jpg, .png">
                <div class="archivo_icono"><i class="fa-solid fa-upload"></i></div>
                <div class="archivo_datos text_left">
                    <div class="archivo_nombre">SELECCIONA...</div>
                    <div class="archivo_tamano">0.00 KB</div>
                </div>
            </label>`,
        showCancelButton: true,
        confirmButtonText: 'Guardar',
        cancelButtonText: 'Cancelar',
        allowOutsideClick: false,
    }).then((r) => {
        // Evaluar la respuesta del usuario
        fotografia_viva     = r.isConfirmed ? cambio_f : fotografia_viva
        val_fotografia_viva = r.isConfirmed ? cambio_v : val_fotografia_viva
        // Cambiar la imagen
        $('.fotografia_viva img').attr('src',fotografia_viva !== '' ? fotografia_viva : `${pin}lib/img/usuario.png`)
        // Limpiar variables
        cambio_f = ''
        cambio_v = 0
    })
    // Funcion para cambiar la fotografia actual
    $(document).on('change','input[name="cambio_f"]',function(){
        // Evaluar el valor
        if($(this).val() !== ''){
            // Agregar la pantalla de carga
            carga(true,1)
            // Agregar una accion de intervalo
            setTimeout(() => {
                // Evaluar la forografia
                $('.imagen img').attr('src',cambio_f)
                // Validar la imagen
                setTimeout(() => {cambio_v = fotografia_validar()},500)
            },500)
        } else {}
    })
}
// Funcion para mostrar la ventana de fotografia viva - Camara
async function fotografia_camara(){
    // Solicitar acceso a las cámaras
    navigator.mediaDevices.getUserMedia({video: true}).then(async (stream) => {
        // Obtener la lista de dispositivos
        var devices = await navigator.mediaDevices.enumerateDevices()
        // Obtener el filtro de dispositivos
        var filtros = [...devices].filter((x) => {return !x.kind.includes('audio')})
        // Obtener la lista de camaras
        var camaras = [];i = 1;for(let x in filtros){camaras.push(`<option value="${filtros[x].deviceId}">Cámara ${i}${filtros[x].label.includes('FRONT') ? ' - FRONTAL' : (filtros[x].label.includes('BACK') ? ' - TRASERA' : '')}</option>`);i++}
        // Evaluar la lista de camaras
        if(camaras.length > 0){
            // Mostrar ventana
            Swal.fire({
                width: 500,
                title: 'Fotografía',
                html: `
                    <div class="imagen">
                        <video  id="video" autoplay muted></video>
                        <canvas id="canva"></canvas>
                    </div>
                    <div class="pregunta topi_1" style="width:100%;margin:0;">
                        <div class="pregunta_texto">Lista de cámaras</div>
                        <select class="pregunta_input camaras">${camaras.join('')}</select>
                    </div>
                    <button class="boton capturar back_rosa"  style="width:calc(50% - 10px);margin: 20px 0 0 0;">CAPTURAR</button>
                    <button class="boton denuevos back_negro" style="width:calc(50% - 10px);margin: 20px 0 0 10px;">TOMAR DE NUEVO</button>`,
                showCancelButton: true,
                confirmButtonText: 'Guardar',
                cancelButtonText: 'Cancelar',
                allowOutsideClick: false,
            }).then((r) => {
                // Evaluar la respuesta del usuario
                fotografia_viva     = r.isConfirmed ? cambio_f : fotografia_viva
                val_fotografia_viva = r.isConfirmed ? cambio_v : val_fotografia_viva
                // Cambiar la imagen
                $('.fotografia_viva img').attr('src',fotografia_viva !== '' ? fotografia_viva : `${pin}lib/img/usuario.png`)
                // Limpiar variables
                cambio_f = ''
                cambio_v = 0
            })
            // Deshabilitar el boton
            $('.swal2-confirm').prop('disabled',true)
            // Obtener el video y el canva
            const video = document.getElementById('video')
            const canva = document.getElementById('canva').getContext('2d')
            // Funcion para cambiar de camara
            $(document).off('change','.camaras').on('change','.camaras',function(){
                // Cambiar de camara
                navigator.mediaDevices.getUserMedia({video:{deviceId:{exact:$(this).val()}}}).then(stream => {video.srcObject = stream})
            }); navigator.mediaDevices.getUserMedia({video:{deviceId:{exact:$('.camaras').val()}}}).then(stream => {video.srcObject = stream})
            // Funcion para capturar la imagen
            $(document).off('click' ,'.capturar').on('click' ,'.capturar',function(){
                // Detener el video
                video.pause()
                // Crear un elemento para almacenar la imagen
                const nuevo = document.createElement('canvas');
                // Obtener el tamaño de la imagen
                nuevo.width = video.videoWidth
                nuevo.height = video.videoHeight
                // Obtener el contenido del video
                const ctx = nuevo.getContext('2d')
                // Insertar la imagen en el canva
                ctx.drawImage(video, 0, 0, nuevo.width, nuevo.height)
                // Agregar la imagen
                cambio_f = nuevo.toDataURL('image/jpeg')
                // Habilitar el guardado
                $('.swal2-confirm').prop('disabled',false)
            })
            // Funcion para tomar de nuevo la imagen
            $(document).off('click' ,'.denuevos').on('click' ,'.denuevos',function(){
                // Detener el video
                video.play()
                // Deshabilitar el guardado
                $('.swal2-confirm').prop('disabled',true)
                // Limpiar variables
                cambio_f = ''
                cambio_v = 0
            })
            // Agregar funcion play para el video
            video.addEventListener('play', async () => {
                // Obtener el tamaño del canva
                const tamanio = { width: video.offsetWidth, height: video.offsetHeight}
                // Agregar las dimensiones al canva
                faceapi.matchDimensions(canva.canvas, tamanio)
                // Agregar un intervalo a las detecciones
                setInterval(async () => {
                    // Detectar rostro
                    const deteccion = await faceapi.detectAllFaces(video, new faceapi.SsdMobilenetv1Options())
                    // Obtener el resultado de la deteccion
                    const resultado = faceapi.resizeResults(deteccion, tamanio)
                    // Limpiar el canva
                    canva.clearRect(0, 0, canva.canvas.width, canva.canvas.height)
                    // Evaluar el resultado
                    if (resultado.length > 0){
                        // Crear caja para mostrar el resultado
                        const box = resultado[0].box
                        canva.strokeStyle = '#48b961'
                        canva.lineWidth = 5
                        canva.strokeRect(box.x, box.y, box.width, box.height)
                        cambio_v = 1
                    } else {cambio_v = 0}
                }, 1000)
            })
            // Mostrar error sobre el soporte del dispositivo
        } else {Swal.fire({width: 400,icon: 'error',html: 'Su dispositivo no soporta esta función'})}
        // Mostrar error de acceso denegado
    }).catch(error => {Swal.fire({width: 400,icon: 'error',html: 'Rechazó el acceso a su cámara'})})
}