// Obtener los estilos root
var style = getComputedStyle(document.body)
var delay
// Configuracion de las graficas
var grafica = {
    animacion: {
        // Evaluar si la craga se ha completado
        onComplete: () => {delay = true},
        // Generar un delay
        delay: (context) => {
            // Variable para almacenar el deley
            let delay = 0;
            // Evaluar la carga
            if (context.type === 'data' && context.mode === 'default' && !delay) {
                // Calcular el delay
                delay = context.dataIndex * 100 + context.datasetIndex * 100;
            } return delay;
        }
    },
    tema: {
        borde : style.getPropertyValue('--fondo_1'),
        fondo : style.getPropertyValue('--fondo_3'),
        texto : style.getPropertyValue('--texto_2'),
        scale : style.getPropertyValue('--charts'),
    },
    data: {
        casilla: {class: 'fondo_azul',texto: 'Total de casillas',icono: '<i class="fa-solid fa-house-signal"></i>'},
        casilla_instalada: {class: 'fondo_morado',texto: 'Casillas instaladas',icono: '<i class="fa-solid fa-house-circle-check"></i>',where: ' AND c2.avance LIKE "%[1%"'},
        casilla_aperturada: {class: 'fondo_verde',texto: 'Casillas aperturadas',icono: '<i class="fa-solid fa-door-open"></i>',where: ' AND c2.avance LIKE "%[1,1%"'},
        casilla_votacion: {class: 'fondo_rojo',texto: 'Casillas en votación',icono: '<i class="fa-solid fa-check-to-slot"></i>',where: ' AND c2.avance LIKE "%[1,1,1,1%"'},
        casilla_cerrada: {class: 'fondo_amarillo',texto: 'Casillas cerradas',icono: '<i class="fa-solid fa-door-closed"></i>',where: ' AND c2.avance LIKE "%[1,1,1,1,1%"'},
        rc: {class: 'fondo_morado',texto: 'Total de RC',icono: '<i class="fa-solid fa-users"></i>'},
        rc_casilla: {class: 'fondo_verde',texto: 'En casilla',icono: '<i class="fa-solid fa-house-user"></i>',where: ' AND c2.avance LIKE "%[1%"'},
        rc_apertura: {class: 'fondo_rojo',texto: 'Aperturaron casilla',icono: '<i class="fa-solid fa-door-open"></i>',where: ' AND c2.avance LIKE "%[1,1%"'},
        rc_votacion: {class: 'fondo_amarillo',texto: 'Iniciaron votación',icono: '<i class="fa-solid fa-check-to-slot"></i>',where: ' AND c2.avance LIKE "%[1,1,1%"'},
        rc_cerrada: {class: 'fondo_azul',texto: 'Cerraron casilla',icono: '<i class="fa-solid fa-door-closed"></i>',where: ' AND c2.avance LIKE "%[1,1,1,1%"'},
        rc_escrutinio: {class: 'fondo_morado',texto: 'Escrutinio y computo',icono: '<i class="fa-solid fa-clipboard-check"></i>',where: ' AND c2.avance LIKE "%[1,1,1,1,1%"'},
        rc_acta: {class: 'fondo_verde',texto: 'Enviaron foto acta',icono: '<i class="fa-solid fa-camera-retro"></i>',where: ' AND c2.avance LIKE "%[1,1,1,1,1,1%"'},
        rc_sabana: {class: 'fondo_rojo',texto: 'Enviaron foto sabana',icono: '<i class="fa-solid fa-camera-retro"></i>',where: ' AND c2.avance LIKE "%[1,1,1,1,1,1,1%"'},
        rc_paquete: {class: 'fondo_amarillo',texto: 'Entregaron paquete',icono: '<i class="fa-solid fa-box-archive"></i>',where: ' AND c2.avance LIKE "%[1,1,1,1,1,1,1,1%"'},
    }
}
// Colores para las graficas
var fondo_gris     = grafica.tema.fondo
var fondo_azul     = 'rgba(50,190,221)'
var fondo_rosa     = 'rgba(246,113,232)'
var fondo_rojo     = 'rgba(255,64,31)'
var fondo_verde    = 'rgba(113,221,55)'
var fondo_morado   = 'rgba(105,108,255)'
var fondo_amarillo = 'rgba(226,159,26)'
// Grafica de dona - generar las configuraciones
const doughnut_option = (data) => {
    // Nuevo arreglo de opciobnes
    return {
        cutout: data.cutout || 0,
        responsive: true,
        borderWidth: 5,
        borderColor: grafica.tema.borde,
        plugins: {
            legend : {display: false},
            tooltip: {enabled: false},
            datalabels: {
                anchor: 'center',
                color: 'white',
                padding: 5,
                font: {weight: 500,size: 12,family: 'sans-serif'},
                borderWidth: 2,
                borderColor: 'white',
                borderRadius: 5,
                backgroundColor:'#566573',
                // Mostrar el valor de cada uno
                formatter: function(e,c){return ((e / c.dataset.data.reduce((x,y) => {return x + y},0) * 100)).toFixed(2)+'%'},
            }
        }
    }
}
// Grafica de linea - generar las configuraciones
const line_option = (data) => {
    // Nuevo arreglo de opciones
    return {
        responsive: true,
        tension: 0.3,
        pointRadius: data.poin_r || 0,
        pointHoverRadius: data.poin_r || 0,
        pointBorderWidth: data.poin_w || 0,
        pointHoverBorderWidth: data.poin_w || 0,
        pointBackgroundColor: grafica.tema.borde,
        pointHoverBackgroundColor: grafica.tema.borde,
        maintainAspectRatio: false,
        interaction: {mode: 'index',intersect: false},
        plugins: {
            legend: {display: false},
            tooltip: {enabled: true},
            datalabels: {
            },
        },
        scales: {
            y: {
                grid: {tickWidth: 0,color: grafica.tema.scale,display: data.grid},
                border: {display: false,dash: [5,5]},
                ticks: {display: false},
                beginAtZero: true
            },
            x: {
                grid: {display: false},
                border: {color: grafica.tema.scale,width: data.border},
                ticks: {color: grafica.tema.texto,font: {size: 12,family: '"Poppins", sans-serif'},padding: 5,display: data.ticks},
            }
        },
        animation: grafica.animacion,
    }
}
// Grafica de barra - generar las configuraciones
const bar_option = (data) => {
    // Nuevo arreglo de opciones
    return {
        responsive: true,
        maintainAspectRatio: false,
        animation: grafica.animacion,
        plugins: {
            legend: {display: false},
            tooltip: {enabled: false},
            datalabels: {
                anchor: 'center',
                color: '#2c3e50',
                padding: 0,
                font: {weight: 600,size: 12,family: 'sans-serif'},
                // Mostrar el valor de cada uno
                formatter: function(e,c){return e},
            },
        },
        scales: {
            y: {
                stacked: true,
                grid: {tickWidth: 0,color: grafica.tema.scale,display: data.grid},
                border: {display: false,dash: [5,5]},
                ticks: {display: false},
                beginAtZero: true
            },
            x: {
                stacked: true,
                grid: {display: false},
                border: {color: grafica.tema.scale,width: data.border},
                ticks: {color: grafica.tema.texto,font: {size: 12,family: '"Poppins", sans-serif'},padding: 5,display: data.ticks},
            }
        },
        interaction: {mode: 'index',intersect: true},
    }
}
// Funcion para generar un numero aleatorio
function aleatorio(min,max){return Math.floor(Math.random() * (max - min + 1)) + min;}
// Funcion para generar el background gradial
function fondo_gradial(c){
    let w, h, g;
    // Elementos del cabvas
    const {ctx, chartArea} = c.chart;
    if(!chartArea){return;}
    // Obtener el tamaño del canvas
    const chart_w = chartArea.right - chartArea.left;
    const chart_h = chartArea.bottom - chartArea.top;
    // Evaluar el tamaño
    if (!g || w !== chart_w || h !== chart_h){
        // Nuevo tamaño
        w = chart_w;
        h = chart_h;
        x = c.dataset.borderColor
        // Crear fondo gradial
        g = ctx.createLinearGradient(0,chartArea.bottom,0,chartArea.top);
        g.addColorStop(0  , x.slice(0,-1)+',0.3)');
        g.addColorStop(0.5, x.slice(0,-1)+',0.5)');
        g.addColorStop(1  , x.slice(0,-1)+',0.7)');
    } return g;
}